import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, continuedIndent, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { ifNotIn, completeFromList, ifIn } from '@codemirror/autocomplete';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_identifier = {__proto__:null,permit:18, forbid:20, principal:132, is:28, in:38, action:138, resource:146, when:56, unless:58, true:62, false:62, has:78, like:80, if:82, then:84, else:86, contains:88, containsAll:90, context:222};
const parser = LRParser.deserialize({
  version: 14,
  states: "5xQYQPOOOOQO'#C`'#C`OeQPO'#DjOOQO'#D`'#D`OYQPO'#C_OjQPO'#C_QYQPOOOOQO'#Dm'#DmOOQO'#D_'#D_OOQO'#Ca'#CaOoQPO,5:UOOQO-E7^-E7^OjQPO,58yOtQPO'#CgO|QPO,58yOOQO-E7]-E7]O!XQPO1G/pO!^QPO1G.eOOQO'#Ci'#CiO!iQPO'#DoOOQO'#Ch'#ChO!wQPO'#DnOOQO,59R,59RO!|QPO,59ROOQO'#Dc'#DcO!^QPO1G.eOOQO1G.e1G.eO#RQPO'#CwO#WQPO7+%[O#]QPO7+$POOQO7+$P7+$POOQO'#Cm'#CmO#hQPO,5:ZO#pQPO'#DxO#hQPO,5:ZOOQO,5:Z,5:ZO#uQPO,5:YOOQO1G.m1G.mOOQO-E7a-E7aO#zQPO,59cOOQO<<Hv<<HvOOQO<<Gk<<GkO$xQPO'#CkOOQO'#Da'#DaO$}QPO,5:eOOQO1G/u1G/uO%VQPO,5:dO%[QPO,5:fOOQO'#Cr'#CrO%dQPO'#DrOOQO'#Cq'#CqO%oQPO1G/tO%tQPO'#D|O%|QPO'#DtOOQO'#Cv'#CvOOQO'#D}'#D}OOQO'#EO'#EOO'fQQO1G.}O#zQPO'#E^O'mQPO'#EkOOQO'#D]'#D]OOQO'#D|'#D|O'uQPO'#EeOOQO,59V,59VOOQO-E7_-E7_OOQO1G0P1G0PO'zQPO1G0OOOQO1G0Q1G0QO#pQPO'#DyO(VQPO,5:^OOQO,5:^,5:^O(_QPO7+%`O(dQPO,5;SOOQO,5:h,5:hO(lQPO'#DuO(tQPO,5:`O(yQPO'#EjO)RQPO,5;TOOQO'#C}'#C}OOQO'#DO'#DOOOQO'#DP'#DPOOQO'#DQ'#DQOOQO'#DR'#DRO#zQPO,5:mO#zQPO,5:mO#zQPO,5:mO#zQPO,5:mO#zQPO,5:mO#zQPO,5:wO)WQPO,5:yO#zQPO,5:|O)cQPO,5:zO#pQPO,5:{O)kQPO,5;OOOQO7+$i7+$iO)pQQO,5:xO)wQQO'#EmO)|QPO'#ElO*UQPO,5;VO*ZQPO,5;PO#pQPO'#DtOOQO1G/x1G/xO*`QPO'#DvOOQO'#Cu'#CuOOQO<<Hz<<HzO#zQPO1G0nO*nQPO,5:aOOQO1G/z1G/zO*vQPO'#DeO+RQPO,5;UOOQO1G0o1G0oOOQO1G0X1G0XO,kQQO1G0XO,uQQO1G0XO.dQQO1G0XO.kQQO1G0XO.rQQO1G0cOOQO1G0e1G0eO.yQPO1G0lO/OQPO1G0mO/TQQO'#EcO/_QPO1G0hOOQO1G0f1G0fO/dQPO1G0gOOQO1G0j1G0jOOQO1G0d1G0dO*vQPO,5;XO'mQPO'#DfO/iQPO,5;WOOQO1G0q1G0qOOQO1G0k1G0kOOQO,5:b,5:bO/qQPO,5:bO/qQPO,5:bO/yQPO7+&YO0OQPO1G/{O#pQPO'#DbOOQO,5:P,5:POOQO-E7c-E7cOOQO7+%}7+%}O#zQPO7+&WO#zQPO7+&XO#zQPO'#DdO0WQPO,5:}OOQO7+&S7+&SO0`QSO7+&ROOQO1G0s1G0sOOQO,5:Q,5:QOOQO-E7d-E7dOOQO1G/|1G/|OOQO<<It<<ItOOQO-E7`-E7`O1yQPO,59|O2RQQO<<IrO2YQQO<<IsO2aQQO,5:OOOQO-E7b-E7bOOQO1G/h1G/hOOQOAN?^AN?^OOQOAN?_AN?_",
  stateData: "2k~O!]OSPOS~OXVOYVO!_PO~O!`XO~OU]O~OU`O~OWfO!dbO~OlkOmkO!QjO~OVlO~OlkOmkO!QnO~O^qOboOcrOd!cX~OdtO~OWuO~OnwO~OWxO~OlkOmkO!QyO~O!`zO!e}O~O!`zO~O!g!QO~OU![OV!XOg!VOn!]Oo!XOp!XOy!`O!`zO!dbO!g!QO!k!WO!s!YO!t!YO#c!^O~O`!aO~OV!cO!`zO~O!`!dO~OV!eO!`zO~OboOc!gOd!fX~Od!iO~OV!kO!`!jO~OV!XOo!XOp!XO!`zO~OU!|O^#OOb!rOc!wOg!zOv!{Ow!}Ox#PO!s!qO!v!pO!w!qO!x!rO!y!rO!z!rO!{!rO!|!rO!}!sO#O!tO~O!O#QO~P&[OV#SO!`#SO~Oz#VO~O`!aOd!liW!li~Og#WO!`zO~O!k!WO~OU#]O`!aO~OV#^O!`zO~Oh#_O~Od#`Oh#^X~Oh#bO~O|#jO}#kO!`#iO~OV#nO!`#nO~OV#pO~OW#qO~P&[O#b#rO~Od#sO!O#`X~O!O#uO~O{#vO~O^qOboOc#yOW!jX~Od#|Oh!ia~OV!XOo!XOp!XO~Od#`Oh#^a~O!v!pOU!ui^!uib!uic!uig!uiv!uiw!uix!ui!O!ui!x!ui!y!ui!z!ui!{!ui!|!ui!}!ui#O!uiW!uih!uid!ui~O!s!ui!w!ui~P+ZO!s!qO!w!qO~P+ZOb!rOc!wO!s!qO!v!pO!w!qO!x!rO!y!rO!z!rO!{!rO!|!rOU!ui^!uig!uiv!uiw!uix!ui!O!ui#O!uiW!uih!uid!ui~O!}!ui~P-PO!}!sO~P-POh$PO~P&[OU$QO~OU$RO~Od$SOW#VX~P&[OW$UO~O!`$VO~Od#sO!O#`a~O!`zO!o$ZO~OW$[O~Od#|Oh!ii~Od$SOW#Va~O`!aOU#Tq^#Tqb#Tqc#Tqg#Tqv#Tqw#Tqx#Tq!O#Tq!s#Tq!v#Tq!w#Tq!x#Tq!y#Tq!z#Tq!{#Tq!|#Tq!}#Tq#O#TqW#Tqh#Tqd#Tq~OV$cO!`zO~OW$dO~P&[OW$eO~P&[OW!Wad!Wa~P&[O",
  goto: ",g#bPPP#c#g#lPPPPP#o#u#xP$[P$}PPP%W%ZPP%m%p&SPPPPP&Y&g&s'O'YPPPPPPPPP#{P'c'i'p(q(w)R)X)_PPP)ePP)j)q)tPP)wP)z*^*bP*e*k*kP*t+k#{PP#{PPPPPPPPP#{#{#{#{#{#{,T#{#{#{#{#{#{,Z#{,^,aTWOUVQOSURYQQ^TRa[Re]Qc]k!_w![!u!v!w!x!y!z!|#]$Q$R$S!a{pqrw|!O!P!U!V![!f!g!l!u!v!w!x!y!z!|#O#W#]#o#x#y#|$Q$R$S$^QpcQ!f!RR#x#YR!TtQ!Rtk!_w![!u!v!w!x!y!z!|#]$Q$R$SR#[!ij!_w![!u!v!w!x!y!z!|#]$Q$R$SR#Y!iXh^aimg!u!Z#R#d#e#f#g#h#l$_$`$ae!v!Z#R#e#f#g#h#l$_$`$ac!w!Z#R#f#g#h#l$_$`$aa!x!Z#R#g#h#l$_$`$a_!y!Z#R#h#l$_$`$aQUOR_USSOURZSU|p!f#xQ!OqU!Pr!g#yj!Uw![!u!v!w!x!y!z!|#]$Q$R$S^!b|!O!P!U!l#o$^S!l!V#WQ#o#OR$^#|Q#{#^R$]#{Qi^QmaTvimQ$T#lR$b$TQ#a!nR$O#aQ#t#TR$Y#tVROSUSTOUR[SRg]Rd]R!Stj!_w![!u!v!w!x!y!z!|#]$Q$R$SR#X!gT!m!V#WR#Z!iQscR#w#YQscQ!h!RR#w#YQ!ZwQ#R![Q#c!uQ#d!vQ#e!wQ#f!xQ#g!yQ#h!zS#l!|#]Q$_$QQ$`$RR$a$Sj!_w![!u!v!w!x!y!z!|#]$Q$R$SQ!n!VQ#}#`R$W#rQ#m!|R#z#]R!o!VR#U!]Q#T!]R$X#s",
  nodeNames: "⚠ LineComment Program Policy At AnnotationKey ( String ) permit forbid Scope PrincipalConstraint Principal is Namespace :: CompareOp == in , ActionConstraint Action [ ] ResourceConstraint Resource Condition when unless { BooleanLiteral Int ArithOp ArithOp CompareOp LogicOp LogicOp . has like if then else contains containsAll } Context ;",
  maxTerm: 111,
  nodeProps: [
    ["isolate", 1,""]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 8,
  tokenData: ",h~RsXY#`YZ#`]^#`pq#`qr#qrs$Otu%lvw&axy&lyz&qz{&v{|&{|}'Q}!O'V!O!P'[!P!Q'a!Q![(O![!](W!]!^(e!^!_(j!_!`(w!`!a)S!a!b)a!b!c+r!c!}%l!}#O+w#P#Q+|#R#S%l#T#o%l#o#p,R#p#q,W#q#r,c$g;'S%l;'S;=`&Z<%lO%l~#eS!]~XY#`YZ#`]^#`pq#`V#vP!tP!_!`#yU$OO!|U~$RVOr$Ors$hs#O$O#O#P$m#P;'S$O;'S;=`%f<%lO$O~$mOV~~$pRO;'S$O;'S;=`$y;=`O$O~$|WOr$Ors$hs#O$O#O#P$m#P;'S$O;'S;=`%f;=`<%l$O<%lO$O~%iP;=`<%l$O~%qW!`~tu%l!Q![%l!c!}%l#R#S%l#T#o%l$g;'S%l;'S;=`&Z<%lO%l~&^P;=`<%l%l~&dPvw&g~&lO!}~~&qOU~~&vOW~~&{O!v~~'QO!w~~'VOd~~'[O!s~~'aOv~~'dP!P!Q'g~'lSP~OY'gZ;'S'g;'S;=`'x<%lO'g~'{P;=`<%l'g~(TPp~!Q![(OV(]P#bQ![!](`T(eO`T~(jO!Q~~(oP!x~!_!`(r~(wO!y~~(zP!_!`(}~)SOb~~)XP!{~!_!`)[~)aO!z~~)dQ#d#e)j#f#g*q~)mP#f#g)p~)sP#]#^)v~)yP#b#c)|~*PP#V#W*S~*VP#]#^*Y~*]P#d#e*`~*cP#T#U*f~*iP#`#a*l~*qO!e~~*tP#X#Y*w~*zP#g#h*}~+QP#c#d+T~+WP#i#j+Z~+^P#f#g+a~+dP#V#W+g~+jP#X#Y+m~+rO!o~~+wO!_~~+|Og~~,ROh~~,WOn~~,ZP#p#q,^~,cO#O~~,hO!O~",
  tokenizers: [0, 1, 2],
  topRules: {"Program":[0,2]},
  specialized: [{term: 62, get: (value) => spec_identifier[value] || -1}],
  tokenPrec: 0
});

let kwCompletion = (name) => ({ label: name, type: "keyword" });
"permit forbid when unless".split(" ").map(kwCompletion);
const cedarLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Scope: continuedIndent(),
                Condition: continuedIndent(),
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Effect: tags.definitionKeyword,
                "permit forbid": tags.definitionKeyword,
                "when unless": tags.keyword,
                "in is has contains containsAll": tags.operatorKeyword,
                "if then else": tags.controlKeyword,
                Identifier: tags.variableName,
                CompareOp: tags.compareOperator,
                BooleanLiteral: tags.bool,
                Principal: tags.variableName,
                Action: tags.variableName,
                Resource: tags.variableName,
                Context: tags.variableName,
                String: tags.string,
                Int: tags.integer,
                LineComment: tags.lineComment,
                At: tags.meta,
                AnnotationKey: tags.meta,
                "( )": tags.paren,
                "{ }": tags.brace,
                "[ ]": tags.squareBracket,
                ";": tags.separator,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: "//" },
    },
});
function cedar() {
    return new LanguageSupport(cedarLanguage, [
        cedarLanguage.data.of({
            autocomplete: ifNotIn(["String", "LineComment", "Scope", "Condition"], completeFromList([
                { label: "permit", type: "keyword" },
                { label: "forbid", type: "keyword" },
            ])),
        }),
        cedarLanguage.data.of({
            autocomplete: ifIn(["Scope"], completeFromList([{ label: "principal", type: "variable" }])),
        }),
        cedarLanguage.data.of({
            autocomplete: ifIn(["ActionConstraint"], completeFromList([{ label: "action", type: "variable" }])),
        }),
    ]);
}

export { cedar, cedarLanguage };
